package pl.afizyka.listawidoku

import android.annotation.SuppressLint
import android.graphics.Color
import android.os.Bundle
import android.view.View
import android.widget.ArrayAdapter
import android.widget.Button
import android.widget.ListView
import android.widget.TextView
import androidx.appcompat.app.AlertDialog
import androidx.appcompat.app.AppCompatActivity

class MainActivity : AppCompatActivity() {
    val idNaglowek= View.generateViewId()
    val idStopka= View.generateViewId()
    val TagNaglowek= "moj_naglowek"
    val tabKrajeUE=arrayOf("Austria", "Belgia", "Bułgaria",
                 "Chorwacja", "Cypr", "Czechy", "Dania",
                 "Estonia", "Finlandia", "Francja", "Grecja",
                 "Hiszpania", "Holandia", "Irlandia", "Litwa",
                 "Luksemburg", "Łotwa", "Malta", "Niemcy",
                 "Polska", "Portugalia", "Rumunia", "Słowacja",
                 "Słowenia", "Szwecja", "Węgry", "Włochy")

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val bt1=findViewById<Button>(R.id.button1)
        bt1.setOnClickListener{ ListaProsta() }

        val bt2=findViewById<Button>(R.id.button2)
        bt2.setOnClickListener{ ListaProstaPobrana_z_Zasobow() }

        val bt3=findViewById<Button>(R.id.button3)
        bt3.setOnClickListener{ ObslugaKlikniecia() }

        val bt4=findViewById<Button>(R.id.button4)
        bt4.setOnClickListener{ LadujNiestandardowaListe() }
    }
    fun ListaProsta(){
        val listView=findViewById<ListView>(R.id.listView)

        val staryNaglowek=listView.findViewById<TextView>(idNaglowek)
        if(staryNaglowek!=null)listView.removeHeaderView(staryNaglowek)
        //val starynaglowek=listView.findViewWithTag<TextView>(TagNaglowek)
        //if(starynaglowek!=null)listView.removeHeaderView(starynaglowek)

        val naglowek=TextView(this)
        naglowek.setTextSize(22f)
        naglowek.setText("Lista prosta pobrana z tablicy")
        naglowek.setBackgroundColor(Color.parseColor("#FFEFA910"))
        naglowek.id=idNaglowek
        naglowek.tag=TagNaglowek
        listView.addHeaderView(naglowek)
        val moj_adapter= ArrayAdapter<String>(this,
            android.R.layout.simple_list_item_1,
            tabKrajeUE)
        listView.adapter=moj_adapter
    }

    fun ListaProstaPobrana_z_Zasobow(){
        val listView=findViewById<ListView>(R.id.listView)

        val staryNaglowek=listView.findViewById<TextView>(idNaglowek)
        if(staryNaglowek!=null)listView.removeHeaderView(staryNaglowek)

        val naglowek=TextView(this)
        naglowek.setTextSize(22f)
        naglowek.setText("Lista prosta pobrana z zasobów")
        naglowek.id=idNaglowek
        naglowek.setBackgroundColor(Color.parseColor("#FFc7241f"))
        listView.addHeaderView(naglowek)
        val tabUE=resources.getStringArray(R.array.KrajeUE)
        tabUE.sort()
        val moj_adapter= ArrayAdapter<String>(this,
            android.R.layout.simple_list_item_1,
            tabUE)
        listView.adapter=moj_adapter
    }

    fun ObslugaKlikniecia(){
        //załaduj listę
        ListaProstaPobrana_z_Zasobow()
        //obsłuz klikniecie w załadowany element listy
        val listView=findViewById<ListView>(R.id.listView)
        listView.setOnItemClickListener { parent, view, position, id ->
            val elementListy=parent.getItemAtPosition(position)
            val oknoKomunikatu=AlertDialog.Builder(this)
            oknoKomunikatu.setTitle("Kliknięto w element listy")
            oknoKomunikatu.setMessage(elementListy.toString()+"\nindeks: "+id.toString())
            oknoKomunikatu.setPositiveButton("Zamknij",null)
            oknoKomunikatu.show()
        }
    }

    fun Naglowek(listView:ListView, tytul:String,kolor:String){
        val staryNaglowek=listView.findViewById<TextView>(idNaglowek)
        if(staryNaglowek!=null)listView.removeHeaderView(staryNaglowek)
        val naglowek=TextView(this)
        naglowek.setTextSize(22f)
        naglowek.setText(tytul)
        naglowek.setBackgroundColor(Color.parseColor(kolor))
        naglowek.id=idNaglowek
        listView.addHeaderView(naglowek)
    }
    fun Stopka(listView:ListView, tytul:String,kolor:String){
        val staraStopka=listView.findViewById<TextView>(idStopka)
        if(staraStopka!=null)listView.removeFooterView(staraStopka)
        val stopka=TextView(this)
        stopka.setTextSize(14f)
        stopka.setText(tytul)
        stopka.setBackgroundColor(Color.parseColor(kolor))
        stopka.id=idStopka
        listView.addFooterView(stopka)
    }
    @SuppressLint("ResourceType")
    fun LadujNiestandardowaListe(){
        val listView=findViewById<ListView>(R.id.listView)
        Naglowek(listView,"Lista niestandardowa- kraje i flagi","#FF94EF8E")
        var listaKrajow = mutableListOf<PrzekazywneDane>()
        val tabKrajeFlagi=resources.obtainTypedArray(R.array.KrajeFlagi)
        for (i in 0.. tabKrajeFlagi.length()-1){
            val tabBufor=resources.obtainTypedArray(tabKrajeFlagi.getResourceId(i,0))
            listaKrajow.add(
                PrzekazywneDane(
                    tabBufor.getString(0).toString(),
                    tabBufor.getResourceId(1, R.drawable.pl),
                    tabBufor.getString(2).toString()
                    )
                )
        }
        listView.adapter=MojAdapterListy(this,R.layout.item_layout_list,listaKrajow)
        Stopka(listView,"Lista zawiera "+listaKrajow.count().toString()+" elementów","#FF94EF8E")
    }
}